
#include "scv.h"
#include "cve.h"

// fsm_state enum

enum fsm_state {
	RESET,
	READ_ROM,
	READ_RAND,
	INST_FETCH,
	INST_DECODE_REG_FETCH,
	MEM_ADDR_COMP,
	MEM_READ,
	WRITE_BCK_STEP,
	MEM_WRITE,
	EXECUTION,
	RTYPE_COMPLETE,
	BRANCH_COMPLETE,
	JUMP_COMPLETE
};


// Extensions for the fsm_state enum

template<>
class scv_extensions<fsm_state> : public scv_enum_base<fsm_state> {
public:
  SCV_ENUM_CTOR(fsm_state) {
    SCV_ENUM(RESET);
    SCV_ENUM(READ_ROM);
    SCV_ENUM(READ_RAND);
    SCV_ENUM(INST_FETCH);
    SCV_ENUM(INST_DECODE_REG_FETCH);
    SCV_ENUM(MEM_ADDR_COMP);
    SCV_ENUM(MEM_READ);
    SCV_ENUM(WRITE_BCK_STEP);
    SCV_ENUM(MEM_WRITE);
    SCV_ENUM(EXECUTION);
    SCV_ENUM(RTYPE_COMPLETE);
    SCV_ENUM(BRANCH_COMPLETE);
    SCV_ENUM(JUMP_COMPLETE);
  }
};

