`timescale 1 ns / 1 ps

module alu ( ALU_result, Zero, ALU_in1, ALU_in2, ALUOp, FCode );
output [31:0] ALU_result;
output Zero;
input [31:0] ALU_in1;
input [31:0] ALU_in2;
input [1:0] ALUOp;
input [5:0] FCode;

reg [31:0] ALU_result;
reg Zero;

//Fcode parameter assignments
parameter 
	ADD = 6'b100000,
	SUB = 6'b100010,
	AND = 6'b100100,
	OR = 6'b100101,
	SOL = 6'b101010;

always_comb
	begin: ALU_COMBO_LOGIC
                if (ALUOp == 2'b00) //ADD
			ALU_result = ALU_in1 + ALU_in2;
		else if (ALUOp[0] == 1'b1) //SUB
			ALU_result = ALU_in1 - ALU_in2;
		else if (ALUOp[1] == 1'b1 && FCode == ADD) //ADD
			ALU_result = ALU_in1 + ALU_in2;
		else if (ALUOp[1] == 1'b1 && FCode == SUB) //SUB
			ALU_result = ALU_in1 - ALU_in2;
		else if (ALUOp[1] == 1 && FCode == AND) //AND
			ALU_result = ALU_in1 & ALU_in2;
		else if (ALUOp[1] == 1 && FCode == OR) //OR
			ALU_result = ALU_in1 | ALU_in2;
		else if (ALUOp[1] == 1 && FCode == SOL) //SOL
			begin
				if (ALU_in1 < ALU_in2)
					ALU_result = 1;
				else
					ALU_result = 0;
			end
		else
			ALU_result = 'bz;
	end

always @(ALU_result)
	begin: ZERO_DETECT
		if (ALU_result == 0)
			Zero = 1;
		else
			Zero = 0;
	end

endmodule

