
module one_hot (a, rst, clock);
input a, rst, clock;
reg rst_n;

parameter [1:0]
S0=2'b00,
S1=2'b01,
S2=2'b10;

reg [2:0] present_state, next_state;
reg my_constant=1'b1;

ial_one_hot #(3) ial_one_hot_inst (.clk(clock),.reset_n(rst_n),.data(present_state),.enable(1'b1));

initial begin
	$monitor("present_state = %b", present_state);
end


always @ (posedge clock or posedge rst) begin
assign rst_n = ~rst;
	if (rst) begin
		present_state = 0;
		present_state[S0] = 1'b1;
	end
	else
		present_state = next_state;
end


//new in 5.6
//Support for guard expression for coverpoints, crosses and bins (Commit)
//Support for parameters in option/type_option values (Commit)
//Support for ignore_bins (Stretch)
//Support for illegal_bins (Stretch)


covergroup cg @(present_state);
FSM: coverpoint present_state {
//example of guard new in 5.6
	bins ps_b1[] = {1,2,4} iff a | my_constant;
//      bins ps_b1[] = {[1:1]};
//	bins ps_b2[] = {[2:2]};
//	bins ps_b3[] = {[4:4]};
}

//  option.cross_auto_bin_max = 20;
//cross MST, FSM1, FSM2, FSM3;

endgroup

cg cg_inst = new();




always @ (present_state or a) begin
	next_state = 0;
	case (1'b1)
		present_state[S0]: begin
			if (a == 1'b1)
				next_state[S1] = 1'b1;
			else
				next_state[S0] = 1'b1;
				next_state[S1] = 1'b1;
			end
		present_state[S1]: begin
			casex (a)
				1'b1: begin
					next_state[S2] = 1'b1;
				end
				default: begin
					next_state[S0] = 1'b1;
				end
			endcase
		end
		present_state[S2]: begin
			if (a == 1'b1)
				next_state[S2] = 1'b1;
			if (a == 1'b0)
				next_state[S0] = 1'b1;
		end
	endcase
end
endmodule

