
module one_hot (a, rst, clock);
input a, rst, clock;

parameter [1:0]
S0=2'b00,
S1=2'b01,
S2=2'b10;

reg [2:0] present_state, next_state;
reg my_constant=1'b1;

always @ (posedge clock or posedge rst) begin
	if (rst) begin
		present_state = 0;
		present_state[S0] = 1'b1;
	end
	else
		present_state = next_state;
end



always @ (present_state or a) begin
	next_state = 0;
	case (1'b1)
		present_state[S0]: begin
			if (a == 1'b1)
				next_state[S1] = 1'b1;
			else
				next_state [S0] = 1'b1;
			end
		present_state[S1]: begin
			casex (a)
				1'b1: begin
					next_state[S2] = 1'b1;
				end
				default: begin
					next_state[S0] = 1'b1;
				end
			endcase
		end
		present_state[S2]: begin
			if (a == 1'b1)
				next_state[S2] = 1'b1;
			if (a == 1'b0)
				next_state[S0] = 1'b1;
		end
	endcase
end
endmodule

