/***************
 * 32X32 MEMORY *
 ***************/

`timescale 1 ns / 1 ps

module registers ( clock, RegWrite, rd_reg1, rd_reg2, wr_reg, wr_data, rd_data1, rd_data2 ) ;

input clock, RegWrite;
input [4:0] rd_reg1;
input [4:0] rd_reg2;
input [4:0] wr_reg;
input [31:0] wr_data;

output [31:0] rd_data1;
output [31:0] rd_data2;

reg [31:0] memory [0:31]; //32x32
reg [31:0] rd_data1;
reg [31:0] rd_data2;


always @(posedge clock) begin
	memory[0] = 0;
	if(RegWrite)
		memory[wr_reg] = wr_data;
	rd_data1 = memory[rd_reg1];
	rd_data2 = memory[rd_reg2];
end

task mem_dump;
        input [31:0] low, high;
        integer i;
        begin
                for( i=low; i<=high; i=i+1 )
                                $display("memory[%d] = %d", i, memory[i]);
//        $stop;
        end
endtask

task mem_dump_stop;
        input [31:0] low, high;
        integer i;
        begin
                for( i=low; i<=high; i=i+1 )
                                $display("memory[%d] = %d", i, memory[i]);
        $stop;
        end
endtask

endmodule
