
module TB_spmn ();

// All port signals have been removed in order to overcome the problem 
//   of wire signals on input nets. These nets need special efforts in 
//   in order to be able to drive them from Specman 
//     (--> verilog signal using wire) 

//new
//typedef enum {RType, IType, JType} InstType_e;
//typedef enum {ADD, SUB, AND, OR, SOL} FuncType_e;
reg [31:0] rand_inst;
reg [5:0] op;
reg [4:0] rs;
reg [4:0] rt;
reg [4:0] rd;
reg [4:0] shamt;
reg [5:0] funct;
reg [15:0] immed;
reg [25:0] target;
reg reset;
reg clock;
reg read_rom;
reg read_rand;

initial begin : READ_ROM
	#50 read_rom = 1'b0;
	#350 read_rom = 1'b1;
	#450 read_rom = 1'b0;
end

initial begin : READ_RAND
	#50 read_rand = 1'b0;
//	#58000 read_rand = 1'b1;
//	#62000 read_rand = 1'b0;
end

initial begin : RESET_process
	#50 reset = 1'b0;
	#50 reset = 1'b1;
	#150 reset = 1'b0;
end

initial begin : CLOCK_process
	clock = 1'b0;
	forever begin
		#50 clock = !clock;
	end
end  

initial #80000 $finish;

always @(posedge reset)
begin:RESET_PORT
	if(reset) begin
		read_rom = 1'b0;
		read_rand = 1'b0;
		rand_inst = 32'b0000_0000_0000_0000_0000_0000_0000_0000;
	end
end

cpu DUT                 (       .clock(clock),
                                .tb_read_rom(read_rom),
                                .tb_read_rand(read_rand),
				.reset(reset),
                                .random_inst(rand_inst)
                        );
endmodule

