File: data_in_s.e

<'

//RType
// | op 6bits | rs 5bits | rt 5bits | rd 5bits | shamt 5bits | funct 6bits |

//IType
// | op 6bits | rs 5bits | rt 5bits | address/immediate 16bits |

//JType
// | op 6bits | target address 26 bits |

type InstType_t : [RType, IType, JType];
type FuncType_t : [ADD, SUB, AND, OR, SOL];

struct data_in_s {
InstType : InstType_t;
FuncType : FuncType_t;

--Port Specific variables
	%rand_inst:		uint (bits: 32);
	%op:			uint (bits: 6);
	%rs:			uint (bits: 5);
	%rt:			uint (bits: 5);
	%rd:			uint (bits: 5);
	%shamt:			uint (bits: 5);
	%funct:			uint (bits: 6);
	%immed:			uint (bits: 16);
	%target:		uint (bits: 26);
------------
keep soft InstType == select {70:RType;20:IType;10:JType;};
keep InstType == RType => op in [0..0];
keep InstType == IType => op in [35..36,43..43];
keep InstType == JType => op in [2..2];

keep soft FuncType == select {22:ADD;22:SUB;22:AND;22:OR;12:SOL;};
keep FuncType == ADD => funct in [32..32];
keep FuncType == SUB => funct in [34..34];
keep FuncType == AND => funct in [36..36];
keep FuncType == OR => funct in [37..37];
keep FuncType == SOL => funct in [42..42];

keep target in [0..255];
keep rs in [0..31];
keep rt in [0..31];
keep rd in [0..31];
keep immed in [0..0];
keep shamt in [0..0];

print_out() is {
outf("rand_inst = %b\n", rand_inst);
outf("op = %b\n", op);
outf("rs = %b\n", rs);
outf("rt = %b\n", rt);
outf("rd = %b\n", rd);
outf("shamt = %b\n", shamt);
outf("funct = %b\n", funct);
outf("immed = %b\n", immed);
outf("target = %b\n", target);
};

        post_generate() is also {
                print_out();
      		emit coverage_gen; 
	 };

	event coverage_gen;
	cover coverage_gen is {
		item rand_inst;
	}

};

'>

