`timescale 1ns / 1ps

module TB1 ();

reg clock;
reg start;
reg load_start;

//V Random input values for Design Under Test
reg [31:0] random_inst;

//Clock
always begin : CLOCK
#50 clock = 1'b0;
#50 clock = 1'b1;
end

//load_start
initial begin :LOAD
#50 load_start = 1'b0;
#50 load_start = 1'b1;
#150 load_start = 1'b0;
end

//Seed
initial begin : SEED
	$vr_set_global_seed(1);
//	$vr_constraint(vr2 >= 0 && vr2 <= 15);
//	$vr_constraint(vr3 >= 0 && vr3 <= 15);
end

//V Random Generated Values
always @(posedge clock) begin : VRANDOM
	$vr_next(random_inst);
//	$display("%d\n", random_inst);
end



always @(clock) begin: END
#70000
$display("--------------Contents of Registers-----------------------");
TB1.DUT.u7.mem_dump_stop( 0, 31 );
end


//Design Under Test Instantiation

cpu DUT                 (       .clock(clock),
                                .tb_read_rom(load_start),
                                .tb_read_rand(load_start),
                                .reset(load_start),
                                .random_inst(random_inst)
                        );

endmodule

